using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml;



namespace SCMFileContentSearch
{
    //Class handles the XML config file that is stored in the Project directory
    public class SCMConfig
    {
        public string configFile = "";
        public SCMConfig(string appPath)
        {
            configFile = appPath + "\\SCMConfig.xml";
        }
        
        
        public string SaveConfigFile(string tempPath, string serverAddress, string serverPort, string scmUserName, string scmPassword)
        {
            XmlDocument xmldoc;
            XmlNode xmlnode;
            XmlElement tempDirElem;
            XmlElement rootElem;
            XmlElement serverElem;
            XmlElement portElem;
            XmlElement userElem;
            XmlElement passwordElem;
           
            XmlText elemText;

            string OutMsg = "";

            xmldoc = new XmlDocument();
            //let's add the XML declaration section
            xmlnode = xmldoc.CreateNode(XmlNodeType.XmlDeclaration, "", "");
            xmldoc.AppendChild(xmlnode);
            //let's add the root element
            rootElem = xmldoc.CreateElement("", "ROOT", "");
            xmldoc.AppendChild(rootElem);

            //let's add another element (child of the root)
            tempDirElem = xmldoc.CreateElement("", "TempDirAddress", "");
            elemText = xmldoc.CreateTextNode(tempPath);
            tempDirElem.AppendChild(elemText);
            xmldoc.ChildNodes.Item(1).AppendChild(tempDirElem);

            serverElem = xmldoc.CreateElement("", "ServerAddress", "");
            elemText = xmldoc.CreateTextNode(serverAddress);
            serverElem.AppendChild(elemText);
            xmldoc.ChildNodes.Item(1).AppendChild(serverElem);

            portElem = xmldoc.CreateElement("", "ServerPort", "");
            elemText = xmldoc.CreateTextNode(serverPort);
            portElem.AppendChild(elemText);
            xmldoc.ChildNodes.Item(1).AppendChild(portElem);

            userElem = xmldoc.CreateElement("", "UserName", "");
            elemText = xmldoc.CreateTextNode(scmUserName);
            userElem.AppendChild(elemText);
            xmldoc.ChildNodes.Item(1).AppendChild(userElem);

            passwordElem = xmldoc.CreateElement("", "Password", "");
            elemText = xmldoc.CreateTextNode(scmPassword);
            passwordElem.AppendChild(elemText);
            xmldoc.ChildNodes.Item(1).AppendChild(passwordElem);

            try
            {

                xmldoc.Save(configFile);
                OutMsg = "yes";
            }
            catch (Exception f)
            {
                OutMsg = f.Message;
            }
            return OutMsg;



        }

      

        //Method to check that file is there

        public bool Exists()
        {

            FileInfo confFile = new FileInfo(configFile);
            if (confFile.Exists)
            {
                return (true);
            }
            else
            {
                return (false);
            }


        }

        //Methods for individual values
        //'get' methods are used to retrieve data from configuration file

        //get the Surround SCM server
        public string getServerAddress()
        {
            string scmServerAddress = "";
            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(configFile);
                mCurrentNode = mDocument.DocumentElement;

                mCurrentNode = mCurrentNode.SelectSingleNode("//ServerAddress");
                scmServerAddress = mCurrentNode.InnerText;


            }
            catch (Exception f)
            {
            }
            return (scmServerAddress);

        }
      
        public string getServerPort()
        {
            string scmServerPort = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(configFile);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//ServerPort");
                scmServerPort = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
            }
            return (scmServerPort);


        }


        public string getSCMUserName()
        {
            string scmUserName = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(configFile);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//UserName");
                scmUserName = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
            }
            return (scmUserName);


        }

        public string getSCMPassword()
        {
            string scmPassword = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(configFile);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//Password");
                scmPassword = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
            }
            return (scmPassword);


        }
        public string getTempDir()
        {
            string scmTempDir = "";

            try
            {

                XmlDocument mDocument;
                XmlNode mCurrentNode;

                mDocument = new XmlDocument();
                mDocument.Load(configFile);
                mCurrentNode = mDocument.DocumentElement;
                mCurrentNode = mCurrentNode.SelectSingleNode("//TempDirAddress");
                scmTempDir = mCurrentNode.InnerText;
            }
            catch (Exception f)
            {
            }
            return (scmTempDir);


        }

        


   
    }
}
