using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

namespace SCMFileContentSearch
{
    public class sscmexe
    {
        //This method is used when we don't care about the SSCM command output (like on the get). Long operations like a recursive get tend to crash 
        //the method below
        public static string sscmCMD_Call(string s_command)
        {
            string m_strSSCMCallResults = null;
            try
            {
                Process sscm = new Process();
                sscm.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                sscm.StartInfo.FileName = "C:\\Program Files\\Seapine\\Surround SCM\\sscm.exe";
                sscm.StartInfo.Arguments = s_command;
                sscm.StartInfo.CreateNoWindow = false;
                sscm.Start();
                sscm.WaitForExit();
                int result = sscm.ExitCode;
              
            }
            catch (Exception e)
            {
                m_strSSCMCallResults = e.Message;
            }
            return (m_strSSCMCallResults);
        }
        //This method we care about the output given by the SSCM command.  May crash if the output is really-really large, like a recursive get.
        //This method is used to get list of mainlines, branches for mainline, and root repo path for branch.
        public static string sscmCMD(string s_command)
        {
            string m_strSSCMCallResults = null;
            try
            {
                Process sscm = new Process();
                sscm.StartInfo.UseShellExecute = false;
                sscm.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                sscm.StartInfo.FileName = "C:\\Program Files\\Seapine\\Surround SCM\\sscm.exe";
                sscm.StartInfo.Arguments = s_command;
                sscm.StartInfo.RedirectStandardOutput = true;
                sscm.StartInfo.CreateNoWindow = true;
                sscm.Start();
                sscm.WaitForExit();
                int result = sscm.ExitCode;

                if (result != 0)
                {
                    m_strSSCMCallResults = "Error: " + sscm.StandardOutput.ReadToEnd();
                }
                else
                {
                    m_strSSCMCallResults = sscm.StandardOutput.ReadToEnd();
                }
           
            }
            catch (Exception e)
            {
                //  Logger.log("SSCM Exception: " + Convert.ToString(e));
                m_strSSCMCallResults = e.Message;
            }
            return (m_strSSCMCallResults);
        }
    }
}
